unit UCalc;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls;

type
  TfrmCalc = class(TForm)
    txtCalc: TEdit;
    btn_7: TButton;
    btn_8: TButton;
    btn_9: TButton;
    btn_div: TButton;
    btn_4: TButton;
    btn_5: TButton;
    btn_6: TButton;
    btn_mult: TButton;
    btn_1: TButton;
    btn_2: TButton;
    btn_3: TButton;
    btn_sub: TButton;
    btn_0: TButton;
    btn_ponto: TButton;
    btn_soma: TButton;
    btn_sinal: TButton;
    btn_sqrt: TButton;
    btn_porc: TButton;
    btn_dec: TButton;
    btn_igual: TButton;
    btn_bkspace: TButton;
    btn_C: TButton;
    Bevel1: TBevel;
    procedure NumeroClick (Sender: TObject);
    procedure btn_sinalClick(Sender: TObject);
    procedure btn_sqrtClick(Sender: TObject);
    procedure btn_CClick(Sender: TObject);
    procedure btn_decClick(Sender: TObject);
    procedure btn_bkspaceClick(Sender: TObject);
    procedure btn_pontoClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure OperacaoClick(Sender: TObject);
    procedure IgualClick(Sender: TObject);
    procedure Inicializa(Sender: TObject);
    procedure btn_porcClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

  TRegistrador = record
    Numero: Real;
    Operador: String;
  end;

const
  MAX_LENGTH = 30;

var
  frmCalc: TfrmCalc;
  Calc   : Boolean;
  Reg    : TRegistrador;
  First  : Boolean; // Viva a POG !!!

implementation

{$R *.DFM}

procedure TfrmCalc.NumeroClick(Sender: TObject);
begin
  if Calc then begin
    txtCalc.Clear;
    Calc := False;
  end;
  if txtCalc.Text = '0' then
    txtCalc.Clear;
  if Length(txtCalc.Text) < MAX_LENGTH then
    txtCalc.Text := txtCalc.Text + (Sender as TButton).Caption;
end;

procedure TfrmCalc.btn_sinalClick(Sender: TObject);
begin
  txtCalc.Text := FloatToStr(StrToFloat(txtCalc.Text) * (-1));
end;

procedure TfrmCalc.btn_sqrtClick(Sender: TObject);
begin
  txtCalc.Text := FloatToStr(sqrt(StrToFloat(txtCalc.Text)));
end;

procedure TfrmCalc.btn_CClick(Sender: TObject);
begin
  txtCalc.Text := '0';
  with Reg do begin
    Operador := '';
    Numero := 0;
  end;
  First := True;
end;

procedure TfrmCalc.btn_decClick(Sender: TObject);
begin
  txtCalc.Text := FloatToStr(1/StrToFloat(txtCalc.Text));
end;

procedure TfrmCalc.btn_bkspaceClick(Sender: TObject);
var Numero: string;
begin
  Numero := txtCalc.Text;
  Delete(Numero, Length(Numero), 1);
  txtCalc.Text := Numero;
  if Length(txtCalc.Text) = 0 then
    txtCalc.Text := '0';
end;

procedure TfrmCalc.btn_pontoClick(Sender: TObject);
begin
  if Pos(',', txtCalc.Text) = 0 then
    txtCalc.Text := txtCalc.Text + ',';
end;

procedure TfrmCalc.OperacaoClick(Sender: TObject);
begin
  with reg do begin
    Operador := (Sender as TButton).Caption;
    if First then Numero := StrToFloat(txtCalc.Text);
  end;
  IgualClick(nil);
end;

procedure TfrmCalc.IgualClick(Sender: TObject);
begin
  if not First then begin
   with Reg do begin
    if Operador = '+' then txtCalc.Text := FloatToStr(StrToFloat(txtCalc.Text) + Numero);
    if Operador = '-' then txtCalc.Text := FloatToStr(Numero - StrToFloat(txtCalc.Text));
    if Operador = '/' then txtCalc.Text := FloatToStr(Numero / StrToFloat(txtCalc.Text));
    if Operador = '*' then txtCalc.Text := FloatToStr(StrToFloat(txtCalc.Text) * Numero);
    Numero := StrToFloat(txtCalc.Text);
   end;
  end;
  Calc := True;
  First:= False;
end;

procedure TfrmCalc.Inicializa(Sender: TObject);
begin
  // Inicializacao das Variaveis
  Calc  := False;
  First := True;
end;

procedure TfrmCalc.FormKeyPress(Sender: TObject; var Key: Char);
begin
  case Key of
    '1': NumeroClick(btn_1);
    '2': NumeroClick(btn_2);
    '3': NumeroClick(btn_3);
    '4': NumeroClick(btn_4);
    '5': NumeroClick(btn_5);
    '6': NumeroClick(btn_6);
    '7': NumeroClick(btn_7);
    '8': NumeroClick(btn_8);
    '9': NumeroClick(btn_9);
    '0': NumeroClick(btn_0);
    chr(43): OperacaoClick(btn_soma);
    chr(45): OperacaoClick(btn_sub);
    chr(42): OperacaoClick(btn_mult);
    chr(47): OperacaoClick(btn_div);
    chr(13): IgualClick(nil);
    chr(8): btn_bkspaceClick(nil);
  end;
      If Key=#27 Then
        Begin
          frmCalc.Close;
      end
end;

procedure TfrmCalc.btn_porcClick(Sender: TObject);
begin
  Reg.Numero := Reg.Numero * (StrToFloat(txtCalc.Text) / 100);
  txtCalc.Text := FloatToStr(Reg.Numero);
end;

procedure TfrmCalc.FormClose(Sender: TObject; var Action: TCloseAction);
begin
Action:=caFree;
frmCalc:=Nil;
end;

end.
